#ifndef command_h__
#define command_h__

#include "ptype.h"
#include "value.h"
#include "bsc_file.h"

typedef enum {
  param_type_null = 0,   /* unused              */
  param_type_expr,       /* generic expression  */
  param_type_cexpr,      /* constant expression */
  param_type_lexpr,      /* logical expression  */
  param_type_assign,     /* assignment          */
  param_type_var,        /* variable            */
  param_type_label,      /* label               */
  param_type_cstr        /* constant string     */
} param_type_t;

typedef struct param_dcr_ {
  param_type_t type;
  void        *param; /* base on type */
} param_dcr_t;

typedef struct {
  param_type_t type;
  union {
    size_t   sval; /* value from the string */
    value_t *var;
    label_t *lbl;
  } u;
} param_t;

typedef void (*parse_fn_t)(bsc_file_t *bsc, unsigned sub_fn, size_t param_ct, 
      const param_t *params);

#endif /* command_h__ */

