/************************************************************
 **
 ** mem.h : memory debugging declarations
 **
 ** Copyright (c) 2004, Kyle A. York
 ** All rights reserved
 **
 ************************************************************/
#ifndef mem_h__
#define mem_h__

#ifdef MEMDEBUG

void *my_malloc(size_t x);
void *my_calloc(size_t x, size_t y);
void  my_free(void *ptr);

#define MALLOC(x)   my_malloc(x)
#define CALLOC(x,y) my_calloc(x, y)
#define FREE(x)     my_free(x)

#else

#include <stdlib.h>

#define MALLOC(x)   malloc(x)
#define CALLOC(x,y) calloc(x, y)
#define FREE(x)     free(x)

#endif

#endif /* mem_h__ */

