/************************************************************
 **
 ** ptype.h : misc. type declarations
 **
 ** Copyright (c) 2004, Kyle A. York
 ** All rights reserved
 **
 ************************************************************/
#ifndef ptype_h__
#define ptype_h__

#include <ctype.h>

#include "bsc_msg.h"

#define COUNT(x) (sizeof(x)/sizeof(*(x)))
#define ISALPHA(x) isalpha((unsigned char) (x))
#define ISDIGIT(x) isdigit((unsigned char) (x))
#define ISXDIGIT(x) isxdigit((unsigned char) (x))
#define ISSPACE(x)  isspace((unsigned char) (x))
#define TOLOWER(x)  tolower((unsigned char) (x))
#define ISOCTDIGIT(x) (('0' == (x)) \
                    || ('1' == (x)) \
                    || ('2' == (x)) \
                    || ('3' == (x)) \
                    || ('4' == (x)) \
                    || ('5' == (x)) \
                    || ('6' == (x)) \
                    || ('7' == (x)))
typedef unsigned short flag_t;  /* flags             */
typedef unsigned short refct_t; /* reference counter */
typedef unsigned short ctr_t;   /* usage counter     */
typedef unsigned short pc_t;    /* program counter   */
typedef unsigned short boolean_t;
/* nb : *never* compare against boolean_true! */
enum {boolean_false, boolean_true};

typedef enum ctr_bump_ {
  ctr_bump_incr = 0,
  ctr_bump_decr
} ctr_bump_t;

typedef struct pfile_        pfile_t;
typedef struct pfile_source_ pfile_source_t;
typedef struct variable_     variable_t;
typedef struct varlist_      varlist_t;
typedef struct label_        label_t;

typedef enum result_ {
  result_ok = 0,    /* no error              */
  result_memory,    /* out of memory         */
  result_syntax,    /* syntax error          */
  result_not_found,
  result_divide_by_zero,
  result_exists,
  result_range,
  result_internal,  /* invalid parameter passed to a function */
  result_invalid
} result_t;


#include "mem.h"

#ifdef MSDOS
#include "pfsrcdcl.h"
#endif /* MSDOS */

#endif /* ptype_h__ */

