/************************************************************
 **
 ** var_decl.h : variable declarations
 **
 ** Copyright (c) 2004, Kyle A. York
 ** All rights reserved
 **
 ************************************************************/
#ifndef var_decl_h__
#define var_decl_h__

struct variable_ {
  slist_el_t         el;        /* element data */

  flag_t             flags;
  char              *name;
  variable_sz_t      sz;        /* element size               */
  variable_ct_t      ct;        /* # of elements (array size) */
  variable_base_t    base;      /* base position              */
  variable_const_t  *data;
  ctr_t              ctr_assign;/* # of times assigned        */
  ctr_t              ctr_use;   /* # of times used            */
  ctr_t              expr_ct;   /* # of expression fragments  */
  /* this doesn't belong here, but I don't know where else to
   * put it. It's a bitmap of in which PIC data banks a variable appears
   * a bank it 128 bytes, so if bits 0 and 2 are set that means
   * the variable exists in the regions [$00,$7f] and [$100,$17f] */
  variable_region_t  region;
};


#endif /* var_decl_h__ */

